org.jboss.netty.channel.socket.nio

## Class NioServerSocketChannelFactory

- java.lang.Object
- - org.jboss.netty.channel.socket.nio.NioServerSocketChannelFactory

All Implemented Interfaces:
  ChannelFactory, ServerChannelFactory, ServerSocketChannelFactory, ExternalResourceReleasable

    public class NioServerSocketChannelFactory
    extends Object
    implements ServerSocketChannelFactory

A `ServerSocketChannelFactory` which creates a server-side NIO-based `ServerSocketChannel`. It utilizes the non-blocking I/O mode which was introduced with NIO to serve many number of concurrent connections efficiently.

### How threads work

There are two types of threads in a `NioServerSocketChannelFactory`; one is boss thread and the other is worker thread.

#### Boss threads

Each bound `ServerSocketChannel` has its own boss thread. For example, if you opened two server ports such as 80 and 443, you will have two boss threads. A boss thread accepts incoming connections until the port is unbound. Once a connection is accepted successfully, the boss thread passes the accepted `Channel` to one of the worker threads that the `NioServerSocketChannelFactory` manages.

#### Worker threads

One `NioServerSocketChannelFactory` can have one or more worker threads. A worker thread performs non-blocking read and write for one or more `Channel`s in a non-blocking mode.

### Life cycle of threads and graceful shutdown

All threads are acquired from the `Executor`s which were specified when a `NioServerSocketChannelFactory` was created. Boss threads are acquired from the `bossExecutor`, and worker threads are acquired from the `workerExecutor`. Therefore, you should make sure the specified `Executor`s are able to lend the sufficient number of threads. It is the best bet to specify a cached thread pool.

Both boss and worker threads are acquired lazily, and then released when there's nothing left to process. All the related resources such as `Selector` are also released when the boss and worker threads are released. Therefore, to shut down a service gracefully, you should do the following:

1. unbind all channels created by the factory,
2. close all child channels accepted by the unbound channels, and (these two steps so far is usually done using `ChannelGroup.close()`)
3. call `releaseExternalResources()`.

Please make sure not to shut down the executor until all channels are closed. Otherwise, you will end up with a `RejectedExecutionException` and the related resources might not be released properly.

### Constructor Summary

Constructors
Constructor and Description
`NioServerSocketChannelFactory()` Create a new `NioServerSocketChannelFactory` using `Executors.newCachedThreadPool()` for the boss and worker.
`NioServerSocketChannelFactory(Executor bossExecutor, Executor workerExecutor)` Creates a new instance.
`NioServerSocketChannelFactory(Executor bossExecutor, Executor workerExecutor, int workerCount)` Creates a new instance.
`NioServerSocketChannelFactory(Executor bossExecutor, WorkerPool<NioWorker> workerPool)` Creates a new instance.

### Method Summary

Methods
`ServerSocketChannel` `newChannel(ChannelPipeline pipeline)` Creates and opens a new `Channel` and attaches the specified `ChannelPipeline` to the new `Channel`.
`void` `releaseExternalResources()` Releases the external resources that this factory depends on to function.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### NioServerSocketChannelFactory

    public NioServerSocketChannelFactory()

Create a new `NioServerSocketChannelFactory` using `Executors.newCachedThreadPool()` for the boss and worker. See `NioServerSocketChannelFactory(Executor, Executor)`

#### NioServerSocketChannelFactory

    public NioServerSocketChannelFactory(Executor bossExecutor,
                                 Executor workerExecutor)

Creates a new instance. Calling this constructor is same with calling `NioServerSocketChannelFactory(Executor, Executor, int)` with 2 * the number of available processors in the machine. The number of available processors is obtained by `Runtime.availableProcessors()`.

Parameters:
  `bossExecutor` - the `Executor` which will execute the boss threads
  `workerExecutor` - the `Executor` which will execute the I/O worker threads

#### NioServerSocketChannelFactory

    public NioServerSocketChannelFactory(Executor bossExecutor,
                                 Executor workerExecutor,
                                 int workerCount)

Creates a new instance.

Parameters:
  `bossExecutor` - the `Executor` which will execute the boss threads
  `workerExecutor` - the `Executor` which will execute the I/O worker threads
  `workerCount` - the maximum number of I/O worker threads

#### NioServerSocketChannelFactory

    public NioServerSocketChannelFactory(Executor bossExecutor,
                                 WorkerPool<NioWorker> workerPool)

Creates a new instance.

Parameters:
  `bossExecutor` - the `Executor` which will execute the boss threads
  `workerPool` - the `WorkerPool` which will be used to obtain the `NioWorker` that execute the I/O worker threads

### Method Detail

#### newChannel

    public ServerSocketChannel newChannel(ChannelPipeline pipeline)

Description copied from interface: `ChannelFactory`
Creates and opens a new `Channel` and attaches the specified `ChannelPipeline` to the new `Channel`.

Specified by:
  `newChannel` in interface `ChannelFactory`
Specified by:
  `newChannel` in interface `ServerChannelFactory`
Specified by:
  `newChannel` in interface `ServerSocketChannelFactory`
Parameters:
  `pipeline` - the `ChannelPipeline` which is going to be attached to the new `Channel`
Returns:
  the newly open channel

#### releaseExternalResources

    public void releaseExternalResources()

Description copied from interface: `ChannelFactory`
Releases the external resources that this factory depends on to function. An external resource is a resource that this factory didn't create by itself. For example, `Executor`s that you specified in the factory constructor are external resources. You can call this method to release all external resources conveniently when the resources are not used by this factory or any other part of your application. An unexpected behavior will be resulted in if the resources are released when there's an open channel which is managed by this factory.

Specified by:
  `releaseExternalResources` in interface `ChannelFactory`
Specified by:
  `releaseExternalResources` in interface `ExternalResourceReleasable`